Option Explicit

'**********************************************************************************************

' GET 32BIT POINTERS TO VB & USER DEFINED DATA TYPES

' HIGHLY recommended that you use the type safe declarations when implementing routine
'-------------------------------------------------------------------------------------

Declare Function bfAddress4Any& Lib "BFVBHLPR.DLL" (lpany As Any)

' Type Safe Declares

' Strings
Declare Function bfAddress4String& Lib "BFVBHLPR.DLL" Alias "bfAddress4Any" (ByVal lpszString$)

' Integers
Declare Function bfAddress4Int& Lib "BFVBHLPR.DLL" Alias "bfAddress4Any" (ByVal lpint%)

'Longs
Declare Function bfAddress4Long& Lib "BFVBHLPR.DLL" Alias "bfAddress4Any" (ByVal lplong&)

' Type Safe Example for use with Structures (types)
' Declare Function bfAddress4RECT& Lib "BFVBHLPR.DLL" Alias "bfAddress4Any" (ByVal rc As RECT)

'-------------------------------------------------------------------------------------

' GET POINTER TO VB STRING

' THIS IS THE PROPER DECLARATION:  DO NOT USE ByVal w/ THIS ROUTINE
Declare Function bfAddressVBStr& Lib "BFVBHLPR.DLL" (vbStr$)

'**********************************************************************************************

' DWORD (long) to LOWORD / HIWORD

' THIS IS THE PROPER DECLARATION:  DO NOT USE ByVal w/ nlo, nhi
Declare Sub bfDWORDto2INT Lib "BFVBHLPR.DLL" (ByVal alng&, nlo%, nhi%)

'**********************************************************************************************

' CONVERT 2 INTEGERS TO DWORD (long)
Declare Function bf2IntsToDWORD& Lib "BFVBHLPR.DLL" (ByVal nlo%, ByVal nhi%)

'**********************************************************************************************

' DISK SPACE ROUTINES

' NOTE:  Values returned are in KB, multiply by 1024 for bytes

' For nDrv parameter:  Drive 0 = Current Drive, 1 = A, 2 = B, 3 = C, etc.
Declare Function bfFreeSpace& Lib "BFVBHLPR.DLL" (ByVal nDrv%)
Declare Function bfUsedDiskSpace& Lib "BFVBHLPR.DLL" (ByVal nDrv%)
Declare Function bfTotalDiskSpace& Lib "BFVBHLPR.DLL" (ByVal nDrv%)

'**********************************************************************************************

' VB STRING ROUTINE(s) - GET VB STRING FROM C STRING (null terminated)


' Obtain a VB String from a long pointer to CString (LPSTR)
Declare Function bfVBStrFromLPSTR$ Lib "BFVBHLPR.DLL" (ByVal lpstr&)

' Obtain a VB String from a null terminated string
' NOTE: DO NOT use on VB Strings w/ embedded NULLs
Declare Function bfVBStrFromString$ Lib "BFVBHLPR.DLL" Alias "bfVBStrFromLPSTR" (ByVal lpstring$)

'**********************************************************************************************

' GET INTEGER FROM POINTER
Declare Function bfIntFromLPINT% Lib "BFVBHLPR.dll" (ByVal lpint&)

' MODIFY INTEGER VALUE USING A POINTER TO THE INTEGER
Declare Sub bfChangeIntValueLPINT Lib "BFVBHLPR.DLL" (ByVal lpint&, ByVal new_value%)

